      module indivtsvars
!****************************************************************
! This module is a component of VINE, copyright by the authors, *
! as listed below. Please see the COPYING and LICENSE files     *
! in the parent directory for additional information.           *
! This notification is present as an attempt to follow the      *
! recommendations for licensing published on the FSF page.      * 
!****************************************************************
!  This file contains the VINE module defining the variables    *
!  and arrays used for the individual timestep routines         *
!                                                               *
!  Written by Andy Nelson, Markus Wetzstein and Thorsten Naab   *
!****************************************************************
      use dimens, only:idim,isphdim,nboddim,ipmdim

      implicit none

      private idim,isphdim,nboddim,ipmdim
      public
      save
!
! integer representation of maximum timestep
!
      integer, parameter::ntimelevs=28
      integer, parameter::imax=2**ntimelevs
      integer, parameter::imaxstep=imax/2
      double precision, parameter::dimaxstep=imaxstep

      integer iactive  (   idim), nactive  , nactivef  ,
     &        iactive_s(isphdim), nactive_s, nactivef_s,
     &        iactive_n(nboddim), nactive_n, nactivef_n,
     &        iactive_c(   idim), nactive_c, nactive_cs,
     &        iactivepm( ipmdim), nactivepm, nactivefpm

      integer iactivepmsav(ipmdim),nactivepmsav,nactivefpmsav

      integer it0  (  idim),it1  (  idim),itstepbin  (  idim),
     &        it0pm(ipmdim),it1pm(ipmdim),itstepbinpm(ipmdim),
     &           now,lastts_end,
     &           levlocc_smldt  ,levlocc_bigdt,
     &           levldone_smldt ,levldone_bigdt,
     &           min_dtbin

      double precision deltat  (  idim),dtrat  (  idim),
     &                 deltatpm(ipmdim),dtratpm(ipmdim),
     &                 dtincr,TWOdtincr

      end module indivtsvars
