      module partvars
!****************************************************************
! This module is a component of VINE, copyright by the authors, *
! as listed below. Please see the COPYING and LICENSE files     *
! in the parent directory for additional information.           *
! This notification is present as an attempt to follow the      *
! recommendations for licensing published on the FSF page.      * 
!****************************************************************
!  This file contains the VINE module defining the variables    *
!  and arrays used hold various information about particles     *
!                                                               *
!  Written by Andy Nelson, Markus Wetzstein and Thorsten Naab   *
!****************************************************************
      use dimens, only: ndim,ndim1,idim,isphdim,ipmdim

      implicit none

      private ndim,ndim1,idim,isphdim,ipmdim
      public

      save
!
! If you add arrays here, be sure to include them in 
! the orderparticles/restoreorder subroutines as well.
!
      integer npoim, npart, npart_sph
      integer nsteppm(ipmdim)

      integer ipindx(idim)
      integer material(isphdim)

      double precision posmas  (ndim1,idim  ),vel  (ndim,idim  ),
     &                 posmaspm(ndim1,ipmdim),velpm(ndim,ipmdim),
     &                 h  (idim  ),poten(idim  ),oldpot  (idim  ),
     &                 hpm(ipmdim),potpm(ipmdim),oldpotpm(ipmdim),
     &     rho (isphdim), rhosave (isphdim), 
     &     divv(isphdim), divvsave(isphdim),
     &     u(isphdim), alpha(isphdim),
     &     spinpm(3,ipmdim)

      double precision dumposmas  (ndim1,idim  ),dumvel  (ndim,idim  ),
     &                 dumposmaspm(ndim1,ipmdim),dumvelpm(ndim,ipmdim),
     &        dumh(idim), dumhpm(ipmdim),
     &        dumu(isphdim),dumalf(isphdim)

      double precision cmpart(ndim), vcmpart(ndim), totmaspart, 
     &                   amompart(4), cmrms(ndim), vcmrms(ndim),
     &                   cmtot (ndim), vcmtot (ndim), totmas,
     &                   amomtot (4),
     &         dumcmpart(ndim), dumvcmpart(ndim), dumtotmaspart, 
     &         dumamompart(4), dumcmrms(ndim), dumvcmrms(ndim),
     &         dumcmtot (ndim), dumvcmtot (ndim), dumtotmas,
     &         dumamomtot (4)

      double precision cmpoim(ndim), vcmpoim(ndim), totmaspoim,
     &                 amompoim(4),
     &         dumcmpoim(ndim), dumvcmpoim(ndim), dumtotmaspoim,
     &         dumamompoim(4)


      integer, parameter::maxstore=200
      integer nstore(ipmdim)
      double precision posmstore (ndim1,ipmdim,maxstore),
     &                 velstore  (ndim ,ipmdim,maxstore),
     &                 spinstore (3    ,ipmdim,maxstore),
     &                 cmstore   (ndim ,ipmdim,maxstore),
     &                 cmtotstore(ndim ,ipmdim,maxstore),
     &                 tmestore  (ipmdim,maxstore)

      character(len=55) pmfile(ipmdim)

      end module partvars
