      subroutine zzsun
!************************************************************
!                                                           *
!  this routine contains all SUN specfic routines           *
!                                                           *
!************************************************************
      implicit none

      integer id,im,iy,ih,is
      integer lnum,ifile,ifsize
      integer my_cpu,numcpus
      double precision fhour

      integer lstat
      external lstat

!$    integer omp_get_num_threads
!$    external omp_get_num_threads
!$    integer omp_get_max_threads
!$    external omp_get_max_threads
!$    integer omp_get_thread_num
!$    external omp_get_thread_num

      integer ivalues(8),istatb(12)

      character(len=11) job
      character(len=7) file
      character(len=8) date
      character(len=10) time
      character(len=5) zone
!
!--flush a buffer out..Useful for running background jobs
!--with output sent to files.
!
      entry bufflush (lnum)
      call flush(lnum)
      return
!
!--get date
!
      entry getdat (id,im,iy)
      call date_and_time(date,time,zone,ivalues)
      iy=ivalues(1)
      im=ivalues(2)
      id=ivalues(3)
      return
!
!--get time
!
      entry getime(ih,im,is,fhour)
      call date_and_time(date,time,zone,ivalues)
      ih=ivalues(5)
      im=ivalues(6)
      is=ivalues(7)
      fhour=ih + im/60. + is/3600.
      return
!
!--random number generator (uniform distribution)
!
!      entry random(randm,idumy)
!      randm=rand()
!      return
!
!--check for file status
!
      entry statfile(file,ifsize)
      ifile=lstat(file,istatb)
      ifsize=istatb(8)
      return
!
!--get argument on command line
!
      entry getcom(job)
      call getarg(1,job)
      return
!
!--Disable Dynamic threading. (i.e. variable cpu count as
!                              the simulation proceeds)
!
      entry fix_numprocessors
!$    call omp_set_dynamic(.false.)
      return
!
!--return number of processors available for job
!
      entry numprocessors(numcpus)
      numcpus=1
!$    numcpus=omp_get_max_threads()
      return
!
!--return number of threads available for the current parallel region
!
      entry numthreads(numcpus)
      numcpus=1
!$    numcpus=omp_get_num_threads()
      return
!
!--return the processor number
!
      entry get_mycpu(my_cpu)
      my_cpu=1
!$    my_cpu=omp_get_thread_num()+1
      return

      end
